Attribute VB_Name = "modCarDBs"
Option Explicit
Type CarInfo
  Name As String
  code As Long
  Racing As Boolean
  Spec As String * 1
End Type

Private CarDB() As CarInfo
Private CarDBLoaded As Boolean

Private Function hex2(ByVal byt As Long) As String
  byt = byt And &HFF
  If byt < 16 Then hex2 = "0" & Hex(byt) Else hex2 = Hex(byt)
End Function

Function CarName(ByVal cix As Integer) As String
  If Not CarDBLoaded Then LoadCarInfo
  If cix < LBound(CarDB) Or cix > UBound(CarDB) Then
    'CarName = "[UNKNOWN CAR " & _
    ' hex2(fileimage(carbase + 3)) & _
    ' hex2(fileimage(carbase + 2)) & ":" & _
    ' hex2(fileimage(carbase + 1)) & _
    ' hex2(fileimage(carbase + 0)) & "]"
    CarName = "[Unknown Car]"
  Else
    CarName = CarDB(cix).Name
  End If
End Function

Function CarIndex(ByVal code As Long) As Integer
  If Not CarDBLoaded Then LoadCarInfo
  Dim i As Integer
  For i = LBound(CarDB) To UBound(CarDB)
    If CarDB(i).code = code Then
      CarIndex = i
      Exit Function
    End If
  Next i
  CarIndex = -1
End Function

Sub LoadCarInfo()
  ReDim CarDB(1 To 600)
  'B458  120C   58 B4 0C 12  B     Acura Integra GS
  Dim f%
  f = FreeFile
  Open App.Path & IIf(Right(App.Path, 1) = "\", "", "\") & "cardata.txt" For Input As f
  Dim s As String
  Line Input #f, s
  ReDim CarDB(1 To CLng(s)) As CarInfo
  Dim i&
  i = 1
  Do While Not EOF(f)
    Line Input #f, s
    If s <> "" Then
      With CarDB(i)
        .Name = Trim(Mid(s, 32))
        .code = CLng("&H" & Mid(s, 7, 4)) * &H10000 + CLng("&H" & Mid(s, 1, 4))
        .Racing = (Mid(s, 30, 1) = "R")
        .Spec = Mid(s, 26, 1)
      End With
      i = i + 1
    End If
  Loop
  Close f
  CarDBLoaded = True
End Sub
